package cn.iocoder.yudao.module.bpm.service.oa;

import cn.hutool.extra.spring.SpringUtil;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.pojo.UploadUserFile;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import liquibase.pro.packaged.T;
import lombok.extern.slf4j.Slf4j;
import org.flowable.common.engine.impl.persistence.entity.EntityManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.lang.reflect.Method;
import java.util.List;

@Service
@Validated
@Slf4j
public class BpmOAAttachmentServiceImpl implements BpmOAAttachmentService {

    /**
     * 更新业务实体的附件信息
     * @param entityClazzs 业务实体
     * @param entityId 业务ID
     * @param fileItems 附件数据
     */
    public void updateAttachment(List<Class<?>> entityClazzs, Long entityId, List<UploadUserFile> fileItems) {
        try {
            // 1. 获取实体, 赋值实体类
            Class doClass = entityClazzs.get(0) ;
            Object entity = doClass.getDeclaredConstructor().newInstance();
            Method setIdMethod = doClass.getMethod("setId", Long.class)  ;
            setIdMethod.invoke(entity, entityId);
            Method setFileItems = doClass.getMethod("setFileItems", List.class)  ;
            setFileItems.invoke(entity, fileItems);
            //获取MyBatist的操作类实体
            Class mapperClass = entityClazzs.get(1) ;
            BaseMapper mapper = (BaseMapper) SpringUtil.getBean(mapperClass);
            mapper.updateById(entity);
        } catch (Exception e) {
            log.error(e.getMessage());
            throw new ServiceException(500, "系统异常，请联系管理员");
        }
    }
}
